#include "dht11.h"

uint8_t dht11_read(uint8_t* temperature, uint8_t* humidity) {
    uint8_t bits[5] = {0};
    uint8_t i, j = 0;

    // ?????? ? ???????
    DHT11_DDR |= (1 << DHT11_INPUTPIN);
    DHT11_PORT &= ~(1 << DHT11_INPUTPIN);
    _delay_ms(18);
    DHT11_PORT |= (1 << DHT11_INPUTPIN);
    _delay_us(40);
    DHT11_DDR &= ~(1 << DHT11_INPUTPIN);

   // if ((DHT11_PIN & (1 << DHT11_INPUTPIN))) return 1;
    _delay_us(80);
   // if (!(DHT11_PIN & (1 << DHT11_INPUTPIN))) return 2;
    _delay_us(80);

    // ?????? 5 ????
    for (j = 0; j < 5; j++) {
        for (i = 0; i < 8; i++) {
            while (!(DHT11_PIN & (1 << DHT11_INPUTPIN))); // ????? ????
            _delay_us(30);
            if (DHT11_PIN & (1 << DHT11_INPUTPIN)) bits[j] |= (1 << (7 - i));
            while (DHT11_PIN & (1 << DHT11_INPUTPIN)); // ???????? ?????????
        }
    }

    // ???????? ??????????? ?????
    if ((uint8_t)(bits[0] + bits[1] + bits[2] + bits[3]) != bits[4])
        return 3;

    *humidity = bits[0];
    *temperature = bits[2];
    return 0;
}